#!/usr/bin/python2.7
# -*- coding: utf-8 -*-

#  Copyright (C) 2014-2015  Rafael Senties Martinelli <rsm@imap.cc>
#
#  This program is free software; you can redistribute it and/or modify
#   it under the terms of the GNU General Public License 3 as published by
#   the Free Software Foundation.
#
#  This program is distributed in the hope that it will be useful,
#   but WITHOUT ANY WARRANTY; without even the implied warranty of
#   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#   GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
#   along with this program; if not, write to the Free Software Foundation,
#   Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301  USA.

import os
from Paths import *
from CustomOs import *; CustomOs=CustomOs()
from inspect import currentframe, getframeinfo

class FilesToReplace(object):
	
	def __init__(self, computer_path, new_id, Data_Location):
		

		self.computer_path=computer_path

		# If the id is an string, convert it to int
		if not isinstance(new_id, (int, long)):
			try:
				self.id=int(new_id)
			except Exception,e: 
				frameinfo = getframeinfo(currentframe())
				print frameinfo.filename, frameinfo.lineno
				print str(e)
				exit()
		else:
			self.id=new_id
			
			
		if self.id >= 0:
			self.stored_path=COMPUTER_DATA_X.format(Data_Location, str(self.id)+"--"+os.path.basename(computer_path))				
		else:
			print "FilesToReplace Error: Not Possitive Id of File to Replace"
			exit()
			
		self.actualize()


	def actualize(self):
		
		if os.path.exists(self.computer_path):
			if os.path.isdir(self.computer_path):
				self.isfile="No"
			else:
				self.isfile="Yes"
		else:
			self.isfile="None"
		
		self.computer_size=CustomOs.GetPathSize_MB(self.computer_path)	
		self.computer_owner=CustomOs.GetOwner(self.computer_path)
		self.computer_date=CustomOs.ModifiedDate_Char(self.computer_path)
		
		self.stored_size=CustomOs.GetPathSize_MB(self.stored_path)
		self.stored_date=CustomOs.ModifiedDate_Char(self.stored_path)	
		self.stored_owner=CustomOs.GetOwner(self.stored_path)
		
		
		if os.path.exists(self.stored_path):
			if self.isfile=="None":
				if os.path.isdir(self.stored_path):
					self.isfile=False
				else:
					self.isfile=True
			else:
				if os.path.isdir(self.stored_path):
					isfile=False
					self.stored_date="Error, not a file."
				else:
					isfile=True

				if self.isfile != isfile:
					self.isfile="FilesToReplace Error: File and Dir."	
		
			
	def get_computer_path(self):
		return self.computer_path
		
	def get_computer_owner(self):
		return self.computer_owner
		
	def get_stored_path(self):
		return self.stored_path
		
	def get_stored_owner(self):
		return self.stored_owner
		
	def get_is_file(self):
		return self.isfile
		
	def get_id(self):
		return self.id
		
	def get_stored_date(self):
		return self.stored_date
		
	def get_computer_date(self):
		return self.computer_date	
		
	def get_stored_size(self):
		return self.stored_size
		
	def get_computer_size(self):
		return self.computer_size
		
	def print_info(self):
		print "--------------------------------"
		print "Id",self.id
		print "Computer Path:",self.computer_path
		print "Stored Path:",self.stored_path
		print "Computer Owner:",self.computer_owner
		print "Stored Owner:",self.stored_owner
		print "Is File:",self.isfile
		print "Computer Date:",self.computer_date
		print "Stored Date:", self.stored_date
		print "Computer Date",self.computer_date
		print "Stored Date",self.stored_date
		print "--------------------------------"
