#!/usr/bin/python2.7
# -*- coding: utf-8 -*-

#  Copyright (C) 2014  Rafael Senties Martinelli <rsm@imap.cc>
#
#  This program is free software; you can redistribute it and/or modify
#   it under the terms of the GNU General Public License 3 as published by
#   the Free Software Foundation.
#
#  This program is distributed in the hope that it will be useful,
#   but WITHOUT ANY WARRANTY; without even the implied warranty of
#   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#   GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
#   along with this program; if not, write to the Free Software Foundation,
#   Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301  USA.

from gi.repository import Gtk
import os, csv

## Imports from other files of Fresh Install
from Paths import *
from Messages import *

from FilesToReplace import *
from FilesToRename import *
from FoldersToReplace import *
from ProgramsToInstall import *
from CustomGtk import *; CustomGtk=CustomGtk()
from inspect import currentframe, getframeinfo

def INIT_TreeView_ProgramsToInstall(self):

		################################
		## TreeView ProgramsToInstall ##
		
		self.ListStore_ProgramsToInstall=Gtk.ListStore(str,str,str,str,str)
		self.treeview_ProgramsToInstall=Gtk.TreeView(model=self.ListStore_ProgramsToInstall)
		self.treeview_ProgramsToInstall.set_rules_hint(True)
		self.treeview_ProgramsToInstall.set_enable_search(True)
		self.treeview_ProgramsToInstall.set_search_column(1)
		self.treeview_ProgramsToInstall.show_all()
		self.treeview_ProgramsToInstall.connect('button-press-event' , self.treeview_right_click_menu)
		self.scrolledwindow_list_of_programs.add(self.treeview_ProgramsToInstall)
		
		self.treeview_ProgramsToInstall_selection=self.treeview_ProgramsToInstall.get_selection()
		self.treeview_ProgramsToInstall_selection.set_mode(Gtk.SelectionMode.MULTIPLE)
		
		cellrenderertext = Gtk.CellRendererText()	
		column = Gtk.TreeViewColumn("Installed")
		column.set_sort_column_id(0)
		self.treeview_ProgramsToInstall.append_column(column)
		column.pack_start(cellrenderertext, True)
		column.add_attribute(cellrenderertext, "text", 0)
		#column.connect("clicked",self.on_sort)
		
		cellrenderertext = Gtk.CellRendererText()	
		column = Gtk.TreeViewColumn("Program")
		column.set_sort_column_id(1)
		column.set_resizable(True)
		self.treeview_ProgramsToInstall.append_column(column)
		column.pack_start(cellrenderertext, True)
		column.add_attribute(cellrenderertext, "text", 1)
		#column.connect("clicked",self.on_sort)
		
		cellrenderertext = Gtk.CellRendererText()	
		column = Gtk.TreeViewColumn("Category")
		column.set_sort_column_id(2)
		column.set_resizable(True)
		self.treeview_ProgramsToInstall.append_column(column)
		column.pack_start(cellrenderertext, True)
		column.add_attribute(cellrenderertext, "text", 2)
		#column.connect("clicked",self.on_sort)
	
		cellrenderertext = Gtk.CellRendererText()	
		column = Gtk.TreeViewColumn("Description")
		column.set_sort_column_id(3)
		column.set_resizable(True)
		self.treeview_ProgramsToInstall.append_column(column)
		column.pack_start(cellrenderertext, True)
		column.add_attribute(cellrenderertext, "text", 3)
		#column.connect("clicked",self.on_sort)	
		
		cellrenderertext = Gtk.CellRendererText()	
		column = Gtk.TreeViewColumn("Comment")
		column.set_sort_column_id(4)
		column.set_resizable(True)
		self.treeview_ProgramsToInstall.append_column(column)
		column.pack_start(cellrenderertext, True)
		column.add_attribute(cellrenderertext, "text", 4)
		#column.connect("clicked",self.on_sort)
		
		
def INIT_TreeView_FilesToReplace(self):

		#############################
		## TreeView FilesToReplace ##
		
		self.ListStore_FilesToReplace=Gtk.ListStore(str,str,str,str,str,str,str)
		self.treeview_FilesToReplace=Gtk.TreeView(model=self.ListStore_FilesToReplace)
		self.treeview_FilesToReplace.set_enable_search(True)
		self.treeview_FilesToReplace.set_search_column(0)
		self.treeview_FilesToReplace.set_rules_hint(True)
		self.treeview_FilesToReplace.connect('button-press-event' , self.treeview_right_click_menu)
		self.treeview_FilesToReplace.show_all()
		self.scrolledwindow_list_files_to_replace.add(self.treeview_FilesToReplace)
		
		
		self.treeview_FilesToReplace_selection=self.treeview_FilesToReplace.get_selection()
		self.treeview_FilesToReplace_selection.set_mode(Gtk.SelectionMode.MULTIPLE)
		

		cellrenderertext = Gtk.CellRendererText()	
		column = Gtk.TreeViewColumn("Computer Path")
		column.set_sort_column_id(0)
		column.set_resizable(True)
		self.treeview_FilesToReplace.append_column(column)
		column.pack_start(cellrenderertext, True)
		column.add_attribute(cellrenderertext, "text", 0)
		#column.connect("clicked",self.on_sort)
		
		cellrenderertext = Gtk.CellRendererText()	
		column = Gtk.TreeViewColumn("Computer Date")
		column.set_sort_column_id(1)
		column.set_resizable(True)
		self.treeview_FilesToReplace.append_column(column)
		column.pack_start(cellrenderertext, True)
		column.add_attribute(cellrenderertext, "text", 1)
		#column.connect("clicked",self.on_sort)
		
		cellrenderertext = Gtk.CellRendererText()	
		column = Gtk.TreeViewColumn("Stored Date")
		column.set_sort_column_id(2)
		column.set_resizable(True)
		self.treeview_FilesToReplace.append_column(column)
		column.pack_start(cellrenderertext, True)
		column.add_attribute(cellrenderertext, "text", 2)
		#column.connect("clicked",self.on_sort)
	
		cellrenderertext = Gtk.CellRendererText()	
		column = Gtk.TreeViewColumn("Computer Owner")
		column.set_sort_column_id(3)
		column.set_resizable(True)
		self.treeview_FilesToReplace.append_column(column)
		column.pack_start(cellrenderertext, True)
		column.add_attribute(cellrenderertext, "text", 3)
		#column.connect("clicked",self.on_sort)	
		
		cellrenderertext = Gtk.CellRendererText()	
		column = Gtk.TreeViewColumn("Stored Owner")
		column.set_sort_column_id(4)
		column.set_resizable(True)
		self.treeview_FilesToReplace.append_column(column)
		column.pack_start(cellrenderertext, True)
		column.add_attribute(cellrenderertext, "text", 4)
		#column.connect("clicked",self.on_sort)
		
		cellrenderertext = Gtk.CellRendererText()	
		column = Gtk.TreeViewColumn("Computer Size MB")
		column.set_sort_column_id(5)
		column.set_resizable(True)
		self.treeview_FilesToReplace.append_column(column)
		column.pack_start(cellrenderertext, True)
		column.add_attribute(cellrenderertext, "text", 5)
		#column.connect("clicked",self.on_sort)
		
		cellrenderertext = Gtk.CellRendererText()	
		column = Gtk.TreeViewColumn("Stored Size MB")
		column.set_sort_column_id(6)
		column.set_resizable(True)
		self.treeview_FilesToReplace.append_column(column)
		column.pack_start(cellrenderertext, True)
		column.add_attribute(cellrenderertext, "text", 6)
		#column.connect("clicked",self.on_sort)
		
def INIT_TreeView_FoldersToReplace(self):

		###############################
		## TreeView FoldersToReplace ##
		
		self.ListStore_FoldersToReplace=Gtk.ListStore(str,str,str,str,str,str,str)
		self.treeview_FoldersToReplace=Gtk.TreeView(model=self.ListStore_FoldersToReplace)
		self.treeview_FoldersToReplace.set_enable_search(True)
		self.treeview_FoldersToReplace.set_search_column(0)
		self.treeview_FoldersToReplace.set_rules_hint(True)
		self.treeview_FoldersToReplace.show_all()
		self.treeview_FoldersToReplace.connect('button-press-event' , self.treeview_right_click_menu)
		self.scrolledwindow_list_folders_to_replace.add(self.treeview_FoldersToReplace)
		
		self.treeview_FoldersToReplace_selection=self.treeview_FoldersToReplace.get_selection()
		self.treeview_FoldersToReplace_selection.set_mode(Gtk.SelectionMode.MULTIPLE)
		
		
		cellrenderertext = Gtk.CellRendererText()	
		column = Gtk.TreeViewColumn("Computer Path")
		column.set_sort_column_id(0)
		column.set_resizable(True)
		self.treeview_FoldersToReplace.append_column(column)
		column.pack_start(cellrenderertext, True)
		column.add_attribute(cellrenderertext, "text", 0)
		#column.connect("clicked",self.on_sort)
		
		cellrenderertext = Gtk.CellRendererText()	
		column = Gtk.TreeViewColumn("Computer Date")
		column.set_sort_column_id(1)
		column.set_resizable(True)
		self.treeview_FoldersToReplace.append_column(column)
		column.pack_start(cellrenderertext, True)
		column.add_attribute(cellrenderertext, "text", 1)
		#column.connect("clicked",self.on_sort)
		
		cellrenderertext = Gtk.CellRendererText()	
		column = Gtk.TreeViewColumn("Stored Date")
		column.set_sort_column_id(2)
		column.set_resizable(True)
		self.treeview_FoldersToReplace.append_column(column)
		column.pack_start(cellrenderertext, True)
		column.add_attribute(cellrenderertext, "text", 2)
		#column.connect("clicked",self.on_sort)
	
		cellrenderertext = Gtk.CellRendererText()	
		column = Gtk.TreeViewColumn("Computer Owner")
		column.set_sort_column_id(3)
		column.set_resizable(True)
		self.treeview_FoldersToReplace.append_column(column)
		column.pack_start(cellrenderertext, True)
		column.add_attribute(cellrenderertext, "text", 3)
		#column.connect("clicked",self.on_sort)	
		
		cellrenderertext = Gtk.CellRendererText()	
		column = Gtk.TreeViewColumn("Stored Owner")
		column.set_sort_column_id(4)
		column.set_resizable(True)
		self.treeview_FoldersToReplace.append_column(column)
		column.pack_start(cellrenderertext, True)
		column.add_attribute(cellrenderertext, "text", 4)
		#column.connect("clicked",self.on_sort)
		
		cellrenderertext = Gtk.CellRendererText()	
		column = Gtk.TreeViewColumn("Computer Size MB")
		column.set_sort_column_id(5)
		column.set_resizable(True)
		self.treeview_FoldersToReplace.append_column(column)
		column.pack_start(cellrenderertext, True)
		column.add_attribute(cellrenderertext, "text", 5)
		#column.connect("clicked",self.on_sort)
		
		cellrenderertext = Gtk.CellRendererText()	
		column = Gtk.TreeViewColumn("Stored Size MB")
		column.set_sort_column_id(6)
		column.set_resizable(True)
		self.treeview_FoldersToReplace.append_column(column)
		column.pack_start(cellrenderertext, True)
		column.add_attribute(cellrenderertext, "text", 6)
		#column.connect("clicked",self.on_sort)
		

def INIT_TreeView_FilesToRename(self):

		#############################
		## TreeView FilesToRename ##
		
		self.ListStore_FilesToRename=Gtk.ListStore(str,str,str,str,float)
		self.treeview_FilesToRename=Gtk.TreeView(model=self.ListStore_FilesToRename)
		self.treeview_FilesToRename.set_enable_search(True)
		self.treeview_FilesToRename.set_search_column(0)
		self.treeview_FilesToRename.set_rules_hint(True)
		self.treeview_FilesToRename.connect('button-press-event' , self.treeview_right_click_menu)
		self.treeview_FilesToRename.show_all()
		self.scrolledwindow_list_files_to_rename.add(self.treeview_FilesToRename)
		
		self.treeview_FilesToRename_selection=self.treeview_FilesToRename.get_selection()
		self.treeview_FilesToRename_selection.set_mode(Gtk.SelectionMode.MULTIPLE)
		

		cellrenderertext = Gtk.CellRendererText()	
		column = Gtk.TreeViewColumn("File Path")
		column.set_sort_column_id(0)
		column.set_resizable(True)
		self.treeview_FilesToRename.append_column(column)
		column.pack_start(cellrenderertext, True)
		column.add_attribute(cellrenderertext, "text", 0)
		#column.connect("clicked",self.on_sort)
		
		cellrenderertext = Gtk.CellRendererText()	
		column = Gtk.TreeViewColumn("New Name")
		column.set_sort_column_id(1)
		column.set_resizable(True)
		self.treeview_FilesToRename.append_column(column)
		column.pack_start(cellrenderertext, True)
		column.add_attribute(cellrenderertext, "text", 1)
		#column.connect("clicked",self.on_sort)
		
		cellrenderertext = Gtk.CellRendererText()	
		column = Gtk.TreeViewColumn("Computer Date")
		column.set_sort_column_id(2)
		column.set_resizable(True)
		self.treeview_FilesToRename.append_column(column)
		column.pack_start(cellrenderertext, True)
		column.add_attribute(cellrenderertext, "text", 2)
		#column.connect("clicked",self.on_sort)
	
		cellrenderertext = Gtk.CellRendererText()	
		column = Gtk.TreeViewColumn("Computer Owner")
		column.set_sort_column_id(3)
		column.set_resizable(True)
		self.treeview_FilesToRename.append_column(column)
		column.pack_start(cellrenderertext, True)
		column.add_attribute(cellrenderertext, "text", 3)
		#column.connect("clicked",self.on_sort)	
		
		cellrenderertext = Gtk.CellRendererText()	
		column = Gtk.TreeViewColumn("Computer Size MB")
		column.set_sort_column_id(4)
		column.set_resizable(True)
		self.treeview_FilesToRename.append_column(column)
		column.pack_start(cellrenderertext, True)
		column.add_attribute(cellrenderertext, "text", 4)
		#column.connect("clicked",self.on_sort)
		


def Initialize_Data_FilesToReplace(self):

	###############################################
	## loading items of the class FilesToReplace ##
	
	self.classlist_files_to_replace=[]
	if os.path.exists(FILES_TO_REPLACE_CSV.format(self.Data_Location)):
		with open(FILES_TO_REPLACE_CSV.format(self.Data_Location),'r') as f:
			rows=csv.reader(f,delimiter='|')
			for row in rows:
				try:
					if row[0].strip():
						self.classlist_files_to_replace.append(FilesToReplace(row[0],row[2],self.Data_Location))
				
				except Exception,e: 
					frameinfo = getframeinfo(currentframe())
					print frameinfo.filename, frameinfo.lineno
					print str(e)
					


def Initialize_Data_FoldersToReplace(self):

	#################################################
	## loading items of the class FoldersToReplace ##
	
	self.classlist_folders_to_replace=[]
	if os.path.exists(FOLDERS_TO_REPLACE_CSV.format(self.Data_Location)):
		with open(FOLDERS_TO_REPLACE_CSV.format(self.Data_Location),'r') as f:
			rows=csv.reader(f,delimiter='|')
			try:
				for row in rows:
					if row[0].strip():
						self.classlist_folders_to_replace.append(FoldersToReplace(row[0],row[2],self.Data_Location))
			

			except Exception,e: 
				frameinfo = getframeinfo(currentframe())
				print frameinfo.filename, frameinfo.lineno
				print str(e)

def Initialize_Data_ProgramsToInstall(self):

	##################################################
	## loading items of the class ProgramsToInstall ##
	
	self.ProgramsToInstall_List=[]
	
	if os.path.exists(PROGRAMS_TO_INSTALL_CSV.format(self.Data_Location)):
		with open(PROGRAMS_TO_INSTALL_CSV.format(self.Data_Location), 'r') as f:
			rows=csv.reader(f,delimiter='|')
			for row in rows:
				try:
					if row[0].strip():
						self.ProgramsToInstall_List.append(ProgramsToInstall(row[0], row[1], 
																			 row[2], row[3], 
																			 GET_ID_ProgramsToInstall(self)))
				except Exception,e: 
					frameinfo = getframeinfo(currentframe())
					print frameinfo.filename, frameinfo.lineno
					print str(e)


def Initialize_Data_FilesToRename(self):

	###############################################
	## loading items of the class FilesToRename ##
	
	self.classlist_files_to_rename=[]
	if os.path.exists(FILES_TO_RENAME_CSV.format(self.Data_Location)):
		with open(FILES_TO_RENAME_CSV.format(self.Data_Location),'r') as f:
			rows=csv.reader(f,delimiter='|')
			for row in rows:
				try:
					if row[0] and row[1]:
						self.classlist_files_to_rename.append(FilesToRename(row[0],row[1],self.Data_Location))
				
				except Exception,e: 
					frameinfo = getframeinfo(currentframe())
					print frameinfo.filename, frameinfo.lineno
					print str(e)



def Populate_ProgramsToInstall_From(self,Choice):
	'''Choice can be "combobox_category2" or "combobox_category" '''

	
	if Choice=="combobox_category2":
		box_category=CustomGtk.retrive_combobox_value(self.combobox_category2,False)
	elif Choice=="combobox_category":
		box_category=CustomGtk.retrive_combobox_value(self.combobox_category,True)
	else:
		print "Populate_ProgramsToInstall_From wrong Choice"
		return

	self.ListStore_ProgramsToInstall.clear()
	
	if box_category==TEXT_SELECT_ALL_THE_CATEGORIES or box_category==TEXT_SELECT_LIST_ALL_THE_CATEGORIES:
		for program in self.ProgramsToInstall_List:

			self.ListStore_ProgramsToInstall.append([	program.get_installed(),
														program.get_apt_name(),
														program.get_category(),
														program.get_description(),
														program.get_comment()])
	else:
		for program in self.ProgramsToInstall_List:
			if program.get_category()==box_category:
				self.ListStore_ProgramsToInstall.append([	program.get_installed(),
															program.get_apt_name(),
															program.get_category(),
															program.get_description(),
															program.get_comment()])


			                                       
	'''                  
	Gdk.threads_enter()
				CustomGtk.info(self.window_install_programs,TEXT_NO_PROGRAM_ON_THIS_CATEGORY,TEXT_THE_LIST_IS_EMPTY)
				Gdk.threads_leave()
				
				'''

def Populate_Files_To_Replace(self):

	entry_replace_filter=self.entry_replace_filter.get_text()
	entry_replace_filter=entry_replace_filter.strip()
	
	entry_replace_modify_path=self.entry_replace_modify_path.get_text()
	entry_replace_modify_path=entry_replace_modify_path.strip()
	
	entry_replace_modify_path2=self.entry_replace_modify_path2.get_text()
	entry_replace_modify_path2=entry_replace_modify_path2.strip()
	
	self.ListStore_FilesToReplace.clear()

	if self.checkbutton_replace_if.get_active() and entry_replace_filter:
		for file in self.classlist_files_to_replace:
			if entry_replace_filter in file.get_computer_path():
				
				path=file.get_computer_path()
				
				if entry_replace_modify_path and entry_replace_modify_path2:

					path=path.replace(entry_replace_modify_path, entry_replace_modify_path2)
				
				
				self.ListStore_FilesToReplace.append([path,
													file.get_computer_date(),file.get_stored_date(),
													file.get_computer_owner(),file.get_stored_owner(),
													str(file.get_computer_size()),str(file.get_stored_size())])
														
	elif self.checkbutton_replace_if_not.get_active() and entry_replace_filter:
		for file in self.classlist_files_to_replace:
			if not entry_replace_filter in file.get_computer_path():
				
				path=file.get_computer_path()
				
				if entry_replace_modify_path and entry_replace_modify_path2:
					path=path.replace(entry_replace_modify_path, entry_replace_modify_path2)
				
				self.ListStore_FilesToReplace.append([path,
													file.get_computer_date(),file.get_stored_date(),
													file.get_computer_owner(),file.get_stored_owner(),
													str(file.get_computer_size()),str(file.get_stored_size())])
	else:
		for file in self.classlist_files_to_replace:
			
			path=file.get_computer_path()
			
			if entry_replace_modify_path and entry_replace_modify_path2:
				path=path.replace(entry_replace_modify_path, entry_replace_modify_path2)
			
			
			self.ListStore_FilesToReplace.append([path,
												file.get_computer_date(),file.get_stored_date(),
												file.get_computer_owner(),file.get_stored_owner(),
												str(file.get_computer_size()),str(file.get_stored_size())])
												
	
def Populate_FilesToRename(self):

	entry_rename_filter=self.entry_rename_filter.get_text()
	entry_rename_filter=entry_rename_filter.strip()
	
	
	self.ListStore_FilesToRename.clear()

	if self.checkbutton_rename_if.get_active() and entry_rename_filter:
		for file in self.classlist_files_to_rename:
			if entry_rename_filter in file.get_computer_path():
				
				self.ListStore_FilesToRename.append([ file.get_computer_path(), file.get_new_name(), 
											file.get_computer_date(), file.get_computer_owner(),
											file.get_computer_size() ])
														
	elif self.checkbutton_rename_if_not.get_active() and entry_rename_filter:
		for file in self.classlist_files_to_rename:
			if not entry_rename_filter in file.get_computer_path():

				self.ListStore_FilesToRename.append([ file.get_computer_path(), file.get_new_name(), 
											file.get_computer_date(), file.get_computer_owner(),
											file.get_computer_size() ])
	else:
		for file in self.classlist_files_to_rename:
			self.ListStore_FilesToRename.append([ file.get_computer_path(), file.get_new_name(), 
											file.get_computer_date(), file.get_computer_owner(),
											file.get_computer_size() ])
	
	
	
	
def Populate_FoldersToReplace(self):

	entry_replace_filter=self.entry_replace_filter.get_text()
	entry_replace_filter=entry_replace_filter.strip()
	
	entry_replace_modify_path=self.entry_replace_modify_path.get_text()
	entry_replace_modify_path=entry_replace_modify_path.strip()
	
	entry_replace_modify_path2=self.entry_replace_modify_path2.get_text()
	entry_replace_modify_path2=entry_replace_modify_path2.strip()
	
	self.ListStore_FoldersToReplace.clear()

	if self.checkbutton_replace_if.get_active() and entry_replace_filter:
		for folder in self.classlist_folders_to_replace:
			if entry_replace_filter in folder.get_computer_path():
				
				path=folder.get_computer_path()
				
				if entry_replace_modify_path and entry_replace_modify_path2:
					path=folder.get_computer_path()
					path=path.replace(entry_replace_modify_path, entry_replace_modify_path2)

				
				self.ListStore_FoldersToReplace.append([path,
														folder.get_computer_date(),folder.get_stored_date(),
														folder.get_computer_owner(),folder.get_stored_owner(),
														str(folder.get_computer_size()),str(folder.get_stored_size())])
														
	elif self.checkbutton_replace_if_not.get_active() and entry_replace_filter:
		for folder in self.classlist_folders_to_replace:
			if not entry_replace_filter in folder.get_computer_path():
				
				path=folder.get_computer_path()
				
				if entry_replace_modify_path and entry_replace_modify_path2:
					path=folder.get_computer_path()
					path=path.replace(entry_replace_modify_path, entry_replace_modify_path2)
				
				
				self.ListStore_FoldersToReplace.append([path,
														folder.get_computer_date(),folder.get_stored_date(),
														folder.get_computer_owner(),folder.get_stored_owner(),
														str(folder.get_computer_size()),str(folder.get_stored_size())])
	else:
		for folder in self.classlist_folders_to_replace:
			
			path=folder.get_computer_path()
			
			
			if entry_replace_modify_path and entry_replace_modify_path2:
				path=folder.get_computer_path()
				path=path.replace(entry_replace_modify_path, entry_replace_modify_path2)
				
				
			self.ListStore_FoldersToReplace.append([path,
													folder.get_computer_date(),folder.get_stored_date(),
													folder.get_computer_owner(),folder.get_stored_owner(),
													str(folder.get_computer_size()),str(folder.get_stored_size())])
	
	'''	
					Gdk.threads_enter()
					CustomGtk.info(self.window_replace,TEXT_THE_LIST_IS_EMPTY,None)
					Gdk.threads_leave()
	'''
			
	'''
	print "Debug FoldersToReplace List"
	i=0
	for item in self.ListStore_FoldersToReplace:
		print self.ListStore_FoldersToReplace[i][0]
		i+=1
	'''
	

def GET_ID_ProgramsToInstall(self):
	id=0
	for program in self.ListStore_ProgramsToInstall:
		id+=1
		
	return id
	
	
	
def Actualize_FoldersToReplace(self):
	for folder in self.classlist_folders_to_replace:
		folder.actualize()

def Actualize_FilesToReplace(self):
	for file in self.classlist_files_to_replace:
		file.actualize()
