#!/usr/bin/python2.7
# -*- coding: utf-8 -*-
#

#  Copyright (C) 2014  Rafael Senties Martinelli <rsm@imap.cc>
#
#  This program is free software; you can redistribute it and/or modify
#   it under the terms of the GNU General Public License 3 as published by
#   the Free Software Foundation.
#
#  This program is distributed in the hope that it will be useful,
#   but WITHOUT ANY WARRANTY; without even the implied warranty of
#   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#   GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
#   along with this program; if not, write to the Free Software Foundation,
#   Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301  USA.

import getpass, os

program_name="fresh-install"

# Software Files and Folders
Script_Location=os.path.dirname(os.path.realpath(__file__))
FRESH_INSTALL_PATH="{0}/{1}.py".format(Script_Location,program_name)
FRESH_INSTALL_GLADE_PATH="{0}/{1}.glade".format(Script_Location,program_name)
LAUNCHER_GLADE_PATH="{0}/launcher.glade".format(Script_Location)

IMAGES="{0}/images".format(Script_Location)
MAIN_ICON_SMALL="{0}/fresh-install-small.png".format(IMAGES)
MAIN_ICON_BIG="{0}/fresh-install-big.png".format(IMAGES)

# Generated Files and Folders
main_folder=".{0}".format(program_name)
MAIN_FOLDER="{0}/{1}".format("{0}",main_folder)
GROUPED_MAIN_FOLDER="/home/{0}".format(main_folder)
ROOT_MAIN_FOLDER="/root/{0}".format(main_folder)
USER_MAIN_FOLDER="/home/{0}/{1}".format(getpass.getuser(),main_folder)
GROUPED_CONFIG_PATH="{0}/{1}.ini".format(GROUPED_MAIN_FOLDER,program_name)
ROOT_CONFIG_PATH="{0}/{1}.ini".format(ROOT_MAIN_FOLDER,program_name)
USER_CONFIG_PATH="{0}/{1}.ini".format(USER_MAIN_FOLDER,program_name)

PROGRAM_DATA="{0}/program-data"
FILES_TO_RENAME_CSV="{0}/Files_to_rename.csv".format(PROGRAM_DATA)
FILES_TO_REPLACE_CSV="{0}/Files_to_replace.csv".format(PROGRAM_DATA)
FOLDERS_TO_REPLACE_CSV="{0}/Folders_to_replace.csv".format(PROGRAM_DATA)
FILES_OR_FOLDERS_TO_REPLACE="{0}/{1}_to_replace.csv".format(PROGRAM_DATA,"{1}")
PROGRAMS_TO_INSTALL_CSV="{0}/programs_to_install.csv".format(PROGRAM_DATA)

COMPUTER_DATA="{0}/computer-data"
COMPUTER_DATA_X="{0}/{1}".format(COMPUTER_DATA,"{1}")

GENERATED_BASH="{0}/install_programs"
GENERATED_BASH_filtred="{0}/install_{1}"

TEMP_APT_LOCKED1="/tmp/fresh-install_apt-locked1"
TEMP_APT_LOCKED2="/tmp/fresh-install_apt-locked2"

TEMP_DATA="{0}/tmp"
FILES_TO_RENAME_filtred="{0}/filtred_Files_to_rename.csv".format(TEMP_DATA)
CATEGORY_PROGRAM_LISTS="{0}/category-programs_lists".format(TEMP_DATA)
CATEGORY_PROGRAM_LISTS_X="{0}/{1}".format(CATEGORY_PROGRAM_LISTS,"{1}")
PROGRAM_LIST="{0}/program_list".format(TEMP_DATA)
PROGRAM_LIST_BY_CATEGORY="{0}/tmp/category-programs_lists/{1}-programs_list"
FILES_OR_FOLDERS_filtred="{0}/filtred_{1}_to_replace.csv".format(TEMP_DATA,"{1}")

INSTAL_PROGRAMS_DATA="{0}/menu-install_programs".format(TEMP_DATA)
INSTALLED_PROGRAMS="{0}/installed_programs.csv".format(INSTAL_PROGRAMS_DATA)
MISSING_PROGRAMS="{0}/missing_programs.csv".format(INSTAL_PROGRAMS_DATA)
INSTALL_PROGRAMS_DATA_X="{0}/{1}_programs.csv".format(INSTAL_PROGRAMS_DATA,"{1}")

USER_ERRORS="{0}/{1}_errors".format(TEMP_DATA,getpass.getuser())
ERROR_RENAMING="{0}/error_renaming".format(USER_ERRORS)
ERROR_UNEXISTING_FILE="{0}/unexisting_file".format(USER_ERRORS)
ERROR_REPLACE_FOLDER="{0}/replace_folder".format(USER_ERRORS)
ERROR_REPLACE_FILE="{0}/replace_file".format(USER_ERRORS)
ERROR_REPLACE_FILES_FOLDERS="{0}/replace_Files_Folders".format(USER_ERRORS)
ERROR_CANT_ACTUALIZE="{0}/cant_actualize".format(USER_ERRORS)

TMP_SYNC_LOCKED_USER="/tmp/fresh-install_RSYNC_locked_{0}"
TMP_SYNC_PROGRESS="/tmp/fresh-install_RSYNC_progress_{0}"
TMP_INSTALLATION_PROGRESS="/tmp/fresh-install_INSTALLATION_progress_{0}"
