#!/usr/bin/python2.7
# -*- coding: utf-8 -*-

#  Copyright (C) 2014  Rafael Senties Martinelli <rsm@imap.cc>
#
#  This program is free software; you can redistribute it and/or modify
#   it under the terms of the GNU General Public License 3 as published by
#   the Free Software Foundation.
#
#  This program is distributed in the hope that it will be useful,
#   but WITHOUT ANY WARRANTY; without even the implied warranty of
#   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#   GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
#   along with this program; if not, write to the Free Software Foundation,
#   Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301  USA.

import os, getpass, thread, time
from gi.repository import Gtk

## Imports from other files of Fresh Install

import sys; sys.path.insert(0, 'GeneralFunctions/')
sys.path.insert(0, 'DataFunctions/')

# imports from GeneralFunctions
from CustomParser import *; CustomParser=CustomParser()

# imports from DataFunctions
from Messages import *
from Paths import *



class GUI_launcher:

	def __init__(self):
		
		self.builder=Gtk.Builder()
		self.builder.add_from_file(LAUNCHER_GLADE_PATH)
		self.builder.connect_signals(self)
		self.remeber_choice=self.builder.get_object('remeber_choice')
		self.window=self.builder.get_object("root_window")
		self.window.show()
		
		if not os.path.exists(USER_CONFIG_PATH) and not os.path.exists(GROUPED_CONFIG_PATH):
			self.remeber_choice.set_inconsistent(True)


	def on_root_window_destroy(self, object, data=None):
		Gtk.main_quit()

	def on_button_quit_clicked(self, button, data=None):
		Gtk.main_quit()
	
	def on_button_skip_clicked(self, button, data=None):
		global Path_File_Config
		
		if Record_Choice:
			CustomParser.write_value(Path_File_Config,Parser_Section,'root_choice','no')
		Gtk.main_quit()
		os.system("setsid setsid '"+FRESH_INSTALL_PATH+"'")

	def on_button_root_clicked(self, button, data=None):
		global Path_File_Config
		
		if Record_Choice:
			CustomParser.write_value(Path_File_Config,Parser_Section,'root_choice','yes')
		Gtk.main_quit()
		
		os.system("setsid setsid gksu -m '"+PROGRAM_PUBLIC_NAME+"' '"+FRESH_INSTALL_PATH+"'")
		
	def on_remeber_choice_toggled(self, checkbutton, data=None):
		
		if not os.path.exists(USER_CONFIG_PATH) and not os.path.exists(GROUPED_CONFIG_PATH):
			self.remeber_choice.set_active(False)
		else:
			global Record_Choice	
			Record_Choice=True

def init_the_launcher():
	if getpass.getuser()=="root":
		os.system("setsid setsid '"+FRESH_INSTALL_PATH+"'")

	elif CustomParser.check_value(Path_File_Config,Parser_Section,'root_choice'):
		root_choice=CustomParser.get_value(Path_File_Config,Parser_Section,'root_choice')
		if root_choice=='yes' and not getpass.getuser()=="root":
			os.system("setsid setsid gksu -m '"+PROGRAM_PUBLIC_NAME+"' '"+FRESH_INSTALL_PATH+"'")
			sys.exit()
		elif root_choice=='no':
			os.system("setsid setsid '"+FRESH_INSTALL_PATH+"'")
			sys.exit()
	else:
		__name__ == "__main__"
		main=GUI_launcher()
		Gtk.main()

Script_Location=os.path.dirname(os.path.realpath(__file__))
	
Path_File_Config=USER_CONFIG_PATH
Parser_Section='fresh-install_configuration'
Record_Choice=False

if CustomParser.get_value(GROUPED_CONFIG_PATH,'fresh-install_configuration','Merged_folders')=="true":
	Path_File_Config=GROUPED_CONFIG_PATH
	if CustomParser.get_value(GROUPED_CONFIG_PATH,'fresh-install_configuration','Merged_configurations')=="true":
		Parser_Section='fresh-install_configuration'
	else:
		Parser_Section="fresh-install_"+getpass.getuser()+"_Configuration"


init_the_launcher()

